
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

typedef struct _GlobalMenuGTKLocator GlobalMenuGTKLocator;

struct _GlobalMenuGTKLocator {
	int dummy;
};



void global_menu_gtk_locator_free (GlobalMenuGTKLocator* self);
static GlobalMenuGTKLocator* global_menu_gtk_locator_new (void);
static GlobalMenuGTKLocator* global_menu_gtk_locator_new (void);
GtkMenuItem* global_menu_gtk_locator_locate (GtkMenuBar* menubar, const char* path);
static void global_menu_gtk_locator_instance_init (GlobalMenuGTKLocator * self);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);



static GlobalMenuGTKLocator* global_menu_gtk_locator_new (void) {
	GlobalMenuGTKLocator* self;
	self = g_slice_new0 (GlobalMenuGTKLocator);
	global_menu_gtk_locator_instance_init (self);
	return self;
}


GtkMenuItem* global_menu_gtk_locator_locate (GtkMenuBar* menubar, const char* path) {
	char** _tmp1_;
	gint tokens_size;
	gint tokens_length1;
	char** _tmp0_;
	char** tokens;
	GtkMenuShell* _tmp2_;
	GtkMenuShell* shell;
	GtkMenuItem* _tmp14_;
	g_return_val_if_fail (menubar != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	tokens = (_tmp1_ = _tmp0_ = g_strsplit_set (path, "/", -1), tokens_length1 = _vala_array_length (_tmp0_), tokens_size = tokens_length1, _tmp1_);
	tokens_length1 = (gint) g_strv_length (tokens);
	_tmp2_ = NULL;
	shell = (_tmp2_ = (GtkMenuShell*) menubar, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
	{
		gint i;
		/*
		weak string rev = tokens[0];
		FIXME: implement the revision */
		i = 1;
		for (; i < tokens_length1; i++) {
			const char* token;
			GtkMenuItem* item;
			GList* children;
			GtkMenuShell* _tmp12_;
			GtkMenuShell* _tmp11_;
			token = tokens[i];
			item = NULL;
			children = gtk_container_get_children ((GtkContainer*) shell);
			if (g_str_has_prefix (token, "W")) {
				gulong pointer;
				pointer = strtoul (g_utf8_offset_to_pointer (token, (glong) 1), NULL, 0);
				/*Widget Pointer*/
				{
					GList* child_collection;
					GList* child_it;
					child_collection = children;
					for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
						GtkWidget* child;
						child = (GtkWidget*) child_it->data;
						{
							if (((gulong) child) == pointer) {
								GtkMenuItem* _tmp5_;
								GtkMenuItem* _tmp4_;
								GtkWidget* _tmp3_;
								_tmp5_ = NULL;
								_tmp4_ = NULL;
								_tmp3_ = NULL;
								item = (_tmp5_ = (_tmp4_ = (_tmp3_ = child, GTK_IS_MENU_ITEM (_tmp3_) ? ((GtkMenuItem*) _tmp3_) : NULL), (_tmp4_ == NULL) ? NULL : g_object_ref (_tmp4_)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), _tmp5_);
								break;
							}
						}
					}
				}
			} else {
				gint position;
				/*assume it is an id*/
				position = atoi (token);
				{
					GList* child_collection;
					GList* child_it;
					child_collection = children;
					for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
						GtkWidget* child;
						child = (GtkWidget*) child_it->data;
						{
							if (GTK_IS_TEAROFF_MENU_ITEM (child)) {
								continue;
							}
							if (position == 0) {
								GtkMenuItem* _tmp8_;
								GtkMenuItem* _tmp7_;
								GtkWidget* _tmp6_;
								_tmp8_ = NULL;
								_tmp7_ = NULL;
								_tmp6_ = NULL;
								item = (_tmp8_ = (_tmp7_ = (_tmp6_ = child, GTK_IS_MENU_ITEM (_tmp6_) ? ((GtkMenuItem*) _tmp6_) : NULL), (_tmp7_ == NULL) ? NULL : g_object_ref (_tmp7_)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), _tmp8_);
								break;
							}
							position--;
						}
					}
				}
			}
			if (i == (tokens_length1 - 1)) {
				GtkMenuItem* _tmp9_;
				_tmp9_ = NULL;
				return (_tmp9_ = item, (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp9_);
			}
			if (item == NULL) {
				GtkMenuItem* _tmp10_;
				_tmp10_ = NULL;
				return (_tmp10_ = NULL, (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp10_);
			}
			_tmp12_ = NULL;
			_tmp11_ = NULL;
			shell = (_tmp12_ = (_tmp11_ = (GtkMenuShell*) gtk_menu_item_get_submenu (item), (_tmp11_ == NULL) ? NULL : g_object_ref (_tmp11_)), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp12_);
			if (shell == NULL) {
				GtkMenuItem* _tmp13_;
				_tmp13_ = NULL;
				return (_tmp13_ = NULL, (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp13_);
			}
			(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
			(children == NULL) ? NULL : (children = (g_list_free (children), NULL));
		}
	}
	_tmp14_ = NULL;
	return (_tmp14_ = NULL, tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp14_);
}


static void global_menu_gtk_locator_instance_init (GlobalMenuGTKLocator * self) {
}


void global_menu_gtk_locator_free (GlobalMenuGTKLocator* self) {
	g_slice_free (GlobalMenuGTKLocator, self);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




