
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdkx.h>
#include <gobject/gvaluecollector.h>


#define GLOBAL_MENU_GTK_TYPE_SERIALIZER (global_menu_gtk_serializer_get_type ())
#define GLOBAL_MENU_GTK_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOBAL_MENU_GTK_TYPE_SERIALIZER, GlobalMenuGTKSerializer))
#define GLOBAL_MENU_GTK_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GLOBAL_MENU_GTK_TYPE_SERIALIZER, GlobalMenuGTKSerializerClass))
#define GLOBAL_MENU_GTK_IS_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOBAL_MENU_GTK_TYPE_SERIALIZER))
#define GLOBAL_MENU_GTK_IS_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GLOBAL_MENU_GTK_TYPE_SERIALIZER))
#define GLOBAL_MENU_GTK_SERIALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GLOBAL_MENU_GTK_TYPE_SERIALIZER, GlobalMenuGTKSerializerClass))

typedef struct _GlobalMenuGTKSerializer GlobalMenuGTKSerializer;
typedef struct _GlobalMenuGTKSerializerClass GlobalMenuGTKSerializerClass;
typedef struct _GlobalMenuGTKSerializerPrivate GlobalMenuGTKSerializerPrivate;
typedef struct _GlobalMenuGTKParamSpecSerializer GlobalMenuGTKParamSpecSerializer;

struct _GlobalMenuGTKSerializer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GlobalMenuGTKSerializerPrivate * priv;
};

struct _GlobalMenuGTKSerializerClass {
	GTypeClass parent_class;
	void (*finalize) (GlobalMenuGTKSerializer *self);
};

struct _GlobalMenuGTKSerializerPrivate {
	GtkMenuBar* menubar;
	GString* sb;
	GString* label_sb;
	gboolean last_item_empty;
	const char* guessed_type;
	gboolean pretty_print;
	gint level;
	gboolean newline;
};

struct _GlobalMenuGTKParamSpecSerializer {
	GParamSpec parent_instance;
};



gpointer global_menu_gtk_serializer_ref (gpointer instance);
void global_menu_gtk_serializer_unref (gpointer instance);
GParamSpec* global_menu_gtk_param_spec_serializer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void global_menu_gtk_value_set_serializer (GValue* value, gpointer v_object);
gpointer global_menu_gtk_value_get_serializer (const GValue* value);
GType global_menu_gtk_serializer_get_type (void);
#define GLOBAL_MENU_GTK_SERIALIZER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GLOBAL_MENU_GTK_TYPE_SERIALIZER, GlobalMenuGTKSerializerPrivate))
enum  {
	GLOBAL_MENU_GTK_SERIALIZER_DUMMY_PROPERTY
};
static GlobalMenuGTKSerializer* global_menu_gtk_serializer_new (void);
static GlobalMenuGTKSerializer* global_menu_gtk_serializer_construct (GType object_type);
static GlobalMenuGTKSerializer* global_menu_gtk_serializer_new (void);
static void global_menu_gtk_serializer_visit (GlobalMenuGTKSerializer* self, GtkWidget* widget);
char* global_menu_gtk_serializer_to_string (GtkMenuBar* menubar, gboolean pretty_print);
static void global_menu_gtk_serializer_visit_menubar (GlobalMenuGTKSerializer* self, GtkMenuBar* menubar);
static void global_menu_gtk_serializer_visit_menu (GlobalMenuGTKSerializer* self, GtkMenu* menu);
static void global_menu_gtk_serializer_visit_menuitem (GlobalMenuGTKSerializer* self, GtkMenuItem* menuitem);
static void global_menu_gtk_serializer_visit_label (GlobalMenuGTKSerializer* self, GtkLabel* label);
static void global_menu_gtk_serializer_visit_image (GlobalMenuGTKSerializer* self, GtkImage* image);
static void global_menu_gtk_serializer_visit_container (GlobalMenuGTKSerializer* self, GtkContainer* container);
static void global_menu_gtk_serializer_indent (GlobalMenuGTKSerializer* self);
static void global_menu_gtk_serializer_linebreak (GlobalMenuGTKSerializer* self);
extern gboolean global_menu_gtk_hybrid;
static void global_menu_gtk_serializer_append_icon_attribute (GlobalMenuGTKSerializer* self, GtkImage* image);
static char* global_menu_gtk_serializer_pixbuf_encode_b64 (GlobalMenuGTKSerializer* self, GdkPixbuf* pixbuf);
extern gboolean global_menu_gtk_disable_pixbuf;
static gpointer global_menu_gtk_serializer_parent_class = NULL;
static void global_menu_gtk_serializer_finalize (GlobalMenuGTKSerializer* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



static GlobalMenuGTKSerializer* global_menu_gtk_serializer_construct (GType object_type) {
	GlobalMenuGTKSerializer* self;
	self = (GlobalMenuGTKSerializer*) g_type_create_instance (object_type);
	return self;
}


static GlobalMenuGTKSerializer* global_menu_gtk_serializer_new (void) {
	return global_menu_gtk_serializer_construct (GLOBAL_MENU_GTK_TYPE_SERIALIZER);
}


char* global_menu_gtk_serializer_to_string (GtkMenuBar* menubar, gboolean pretty_print) {
	GlobalMenuGTKSerializer* s;
	GTimer* timer;
	GtkMenuBar* _tmp1_;
	GtkMenuBar* _tmp0_;
	GString* _tmp2_;
	GString* _tmp3_;
	const char* _tmp4_;
	char* _tmp5_;
	g_return_val_if_fail (menubar != NULL, NULL);
	s = global_menu_gtk_serializer_new ();
	timer = g_timer_new ();
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	s->priv->menubar = (_tmp1_ = (_tmp0_ = menubar, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (s->priv->menubar == NULL) ? NULL : (s->priv->menubar = (g_object_unref (s->priv->menubar), NULL)), _tmp1_);
	s->priv->pretty_print = pretty_print;
	_tmp2_ = NULL;
	s->priv->sb = (_tmp2_ = g_string_new (""), (s->priv->sb == NULL) ? NULL : (s->priv->sb = (g_string_free (s->priv->sb, TRUE), NULL)), _tmp2_);
	_tmp3_ = NULL;
	s->priv->label_sb = (_tmp3_ = g_string_new (""), (s->priv->label_sb == NULL) ? NULL : (s->priv->label_sb = (g_string_free (s->priv->label_sb, TRUE), NULL)), _tmp3_);
	global_menu_gtk_serializer_visit (s, (GtkWidget*) menubar);
	g_debug ("globalmenu-serializer.vala:15: Serializer consumption = %lf", g_timer_elapsed (timer, NULL));
	_tmp4_ = NULL;
	_tmp5_ = NULL;
	return (_tmp5_ = (_tmp4_ = s->priv->sb->str, (_tmp4_ == NULL) ? NULL : g_strdup (_tmp4_)), (s == NULL) ? NULL : (s = (global_menu_gtk_serializer_unref (s), NULL)), (timer == NULL) ? NULL : (timer = (g_timer_destroy (timer), NULL)), _tmp5_);
}


static void global_menu_gtk_serializer_visit (GlobalMenuGTKSerializer* self, GtkWidget* widget) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	if (GTK_IS_MENU_BAR (widget)) {
		GtkWidget* _tmp0_;
		_tmp0_ = NULL;
		global_menu_gtk_serializer_visit_menubar (self, (_tmp0_ = widget, GTK_IS_MENU_BAR (_tmp0_) ? ((GtkMenuBar*) _tmp0_) : NULL));
	} else {
		if (GTK_IS_MENU (widget)) {
			GtkWidget* _tmp1_;
			_tmp1_ = NULL;
			global_menu_gtk_serializer_visit_menu (self, (_tmp1_ = widget, GTK_IS_MENU (_tmp1_) ? ((GtkMenu*) _tmp1_) : NULL));
		} else {
			if (GTK_IS_MENU_ITEM (widget)) {
				GtkWidget* _tmp2_;
				_tmp2_ = NULL;
				global_menu_gtk_serializer_visit_menuitem (self, (_tmp2_ = widget, GTK_IS_MENU_ITEM (_tmp2_) ? ((GtkMenuItem*) _tmp2_) : NULL));
			} else {
				if (GTK_IS_LABEL (widget)) {
					GtkWidget* _tmp3_;
					_tmp3_ = NULL;
					global_menu_gtk_serializer_visit_label (self, (_tmp3_ = widget, GTK_IS_LABEL (_tmp3_) ? ((GtkLabel*) _tmp3_) : NULL));
				} else {
					if (GTK_IS_IMAGE (widget)) {
						GtkWidget* _tmp4_;
						_tmp4_ = NULL;
						global_menu_gtk_serializer_visit_image (self, (_tmp4_ = widget, GTK_IS_IMAGE (_tmp4_) ? ((GtkImage*) _tmp4_) : NULL));
					} else {
						if (GTK_IS_CONTAINER (widget)) {
							GtkWidget* _tmp5_;
							_tmp5_ = NULL;
							global_menu_gtk_serializer_visit_container (self, (_tmp5_ = widget, GTK_IS_CONTAINER (_tmp5_) ? ((GtkContainer*) _tmp5_) : NULL));
						}
					}
				}
			}
		}
	}
}


static void global_menu_gtk_serializer_visit_container (GlobalMenuGTKSerializer* self, GtkContainer* container) {
	GList* children;
	g_return_if_fail (self != NULL);
	g_return_if_fail (container != NULL);
	children = gtk_container_get_children (container);
	g_debug ("globalmenu-serializer.vala:33: %p has %u children", container, g_list_length (children));
	{
		GList* child_collection;
		GList* child_it;
		child_collection = children;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child;
			child = (GtkWidget*) child_it->data;
			{
				global_menu_gtk_serializer_visit (self, child);
			}
		}
	}
	(children == NULL) ? NULL : (children = (g_list_free (children), NULL));
}


static void global_menu_gtk_serializer_visit_menubar (GlobalMenuGTKSerializer* self, GtkMenuBar* menubar) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (menubar != NULL);
	global_menu_gtk_serializer_indent (self);
	g_string_append (self->priv->sb, "<menu>");
	global_menu_gtk_serializer_linebreak (self);
	self->priv->level++;
	global_menu_gtk_serializer_visit_container (self, (GtkContainer*) menubar);
	self->priv->level--;
	global_menu_gtk_serializer_indent (self);
	g_string_append (self->priv->sb, "</menu>");
	global_menu_gtk_serializer_linebreak (self);
}


static void global_menu_gtk_serializer_visit_menu (GlobalMenuGTKSerializer* self, GtkMenu* menu) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	global_menu_gtk_serializer_indent (self);
	g_string_append (self->priv->sb, "<menu>");
	global_menu_gtk_serializer_linebreak (self);
	global_menu_gtk_serializer_visit_container (self, (GtkContainer*) menu);
	global_menu_gtk_serializer_indent (self);
	g_string_append (self->priv->sb, "</menu>");
	global_menu_gtk_serializer_linebreak (self);
}


static void global_menu_gtk_serializer_visit_menuitem (GlobalMenuGTKSerializer* self, GtkMenuItem* menuitem) {
	char* _tmp0_;
	gboolean _tmp2_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menuitem != NULL);
	if (GTK_IS_TEAROFF_MENU_ITEM (menuitem)) {
		return;
	}
	global_menu_gtk_serializer_indent (self);
	g_string_append (self->priv->sb, "<item");
	_tmp0_ = NULL;
	g_string_append (self->priv->sb, _tmp0_ = g_markup_printf_escaped (" id=\"W%lu\"", (gulong) menuitem));
	_tmp0_ = (g_free (_tmp0_), NULL);
	if (global_menu_gtk_hybrid) {
		g_string_append (self->priv->sb, " client-side=\"1\"");
	}
	g_string_erase (self->priv->label_sb, (glong) 0, (glong) (-1));
	self->priv->last_item_empty = TRUE;
	self->priv->guessed_type = NULL;
	global_menu_gtk_serializer_visit_container (self, (GtkContainer*) menuitem);
	if (self->priv->label_sb->len > 0) {
		char* _tmp1_;
		_tmp1_ = NULL;
		g_string_append (self->priv->sb, _tmp1_ = g_markup_printf_escaped (" label=\"%s\"", self->priv->label_sb->str));
		_tmp1_ = (g_free (_tmp1_), NULL);
		self->priv->last_item_empty = FALSE;
	}
	_tmp2_ = FALSE;
	if (GTK_IS_SEPARATOR_MENU_ITEM (menuitem)) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = gtk_bin_get_child ((GtkBin*) menuitem) == NULL;
	}
	if (_tmp2_) {
		self->priv->guessed_type = "s";
		self->priv->last_item_empty = FALSE;
	}
	if (GTK_IS_IMAGE_MENU_ITEM (menuitem)) {
		GtkImage* _tmp5_;
		GtkMenuItem* _tmp3_;
		GtkWidget* _tmp4_;
		GtkImage* image;
		_tmp5_ = NULL;
		_tmp3_ = NULL;
		_tmp4_ = NULL;
		image = (_tmp5_ = (_tmp4_ = gtk_image_menu_item_get_image ((_tmp3_ = menuitem, GTK_IS_IMAGE_MENU_ITEM (_tmp3_) ? ((GtkImageMenuItem*) _tmp3_) : NULL)), GTK_IS_IMAGE (_tmp4_) ? ((GtkImage*) _tmp4_) : NULL), (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_));
		if (image != NULL) {
			self->priv->guessed_type = "i";
			global_menu_gtk_serializer_append_icon_attribute (self, image);
			self->priv->last_item_empty = FALSE;
		}
		(image == NULL) ? NULL : (image = (g_object_unref (image), NULL));
	}
	if (GTK_IS_CHECK_MENU_ITEM (menuitem)) {
		GtkCheckMenuItem* _tmp7_;
		GtkMenuItem* _tmp6_;
		GtkCheckMenuItem* checkmenuitem;
		_tmp7_ = NULL;
		_tmp6_ = NULL;
		checkmenuitem = (_tmp7_ = (_tmp6_ = menuitem, GTK_IS_CHECK_MENU_ITEM (_tmp6_) ? ((GtkCheckMenuItem*) _tmp6_) : NULL), (_tmp7_ == NULL) ? NULL : g_object_ref (_tmp7_));
		if (gtk_check_menu_item_get_draw_as_radio (checkmenuitem)) {
			self->priv->guessed_type = "r";
		} else {
			self->priv->guessed_type = "c";
		}
		if (!gtk_check_menu_item_get_inconsistent (checkmenuitem)) {
			if (gtk_check_menu_item_get_active (checkmenuitem)) {
				g_string_append (self->priv->sb, " state=\"1\"");
			} else {
				g_string_append (self->priv->sb, " state=\"0\"");
			}
		}
		self->priv->last_item_empty = FALSE;
		(checkmenuitem == NULL) ? NULL : (checkmenuitem = (g_object_unref (checkmenuitem), NULL));
	}
	if ((g_object_get ((GtkWidget*) menuitem, "visible", &_tmp8_, NULL), _tmp8_) == FALSE) {
		g_string_append (self->priv->sb, " visible=\"0\"");
		self->priv->last_item_empty = FALSE;
	}
	if ((g_object_get ((GtkWidget*) menuitem, "sensitive", &_tmp9_, NULL), _tmp9_) == FALSE) {
		g_string_append (self->priv->sb, " sensitive=\"0\"");
	}
	if (self->priv->last_item_empty) {
		/* hide the empty items with
		 * no label, no image, or
		 * any other visible elements.
		 *
		 * eg, PidginMenuTray
		 * */
		g_string_append (self->priv->sb, " visible=\"0\"");
	}
	if (self->priv->guessed_type != NULL) {
		g_string_append_printf (self->priv->sb, " type=\"%s\"", self->priv->guessed_type);
	}
	if (gtk_menu_item_get_submenu (menuitem) == NULL) {
		g_string_append (self->priv->sb, "/>");
		global_menu_gtk_serializer_linebreak (self);
	} else {
		g_string_append_c (self->priv->sb, '>');
		global_menu_gtk_serializer_linebreak (self);
		self->priv->level++;
		if (gtk_menu_item_get_submenu (menuitem) != NULL) {
			global_menu_gtk_serializer_visit_menu (self, gtk_menu_item_get_submenu (menuitem));
		}
		self->priv->level--;
		global_menu_gtk_serializer_indent (self);
		g_string_append (self->priv->sb, "</item>");
		global_menu_gtk_serializer_linebreak (self);
	}
}


static glong string_get_length (const char* self) {
	g_return_val_if_fail (self != NULL, 0L);
	return g_utf8_strlen (self, -1);
}


static void global_menu_gtk_serializer_visit_label (GlobalMenuGTKSerializer* self, GtkLabel* label) {
	const char* _tmp0_;
	char* label_text;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	_tmp0_ = NULL;
	label_text = (_tmp0_ = gtk_label_get_label (label), (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
	g_string_append (self->priv->label_sb, label_text);
	g_debug ("globalmenu-serializer.vala:145: append text = %s", label_text);
	if (GTK_IS_ACCEL_LABEL (label)) {
		GtkLabel* _tmp1_;
		const char* _tmp3_;
		GtkLabel* _tmp2_;
		char* accel_string;
		gboolean _tmp4_;
		_tmp1_ = NULL;
		gtk_accel_label_refetch ((_tmp1_ = label, GTK_IS_ACCEL_LABEL (_tmp1_) ? ((GtkAccelLabel*) _tmp1_) : NULL));
		_tmp3_ = NULL;
		_tmp2_ = NULL;
		accel_string = (_tmp3_ = (_tmp2_ = label, GTK_IS_ACCEL_LABEL (_tmp2_) ? ((GtkAccelLabel*) _tmp2_) : NULL)->accel_string, (_tmp3_ == NULL) ? NULL : g_strdup (_tmp3_));
		g_strstrip (accel_string);
		_tmp4_ = FALSE;
		if (string_get_length (accel_string) > 0) {
			_tmp4_ = _vala_strcmp0 (accel_string, "-/-") != 0;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			char* _tmp5_;
			/*refer to gtkaccellabel.c:802*/
			_tmp5_ = NULL;
			g_string_append (self->priv->sb, _tmp5_ = g_markup_printf_escaped (" accel=\"%s\"", accel_string));
			_tmp5_ = (g_free (_tmp5_), NULL);
		}
		accel_string = (g_free (accel_string), NULL);
	}
	label_text = (g_free (label_text), NULL);
}


static void global_menu_gtk_serializer_visit_image (GlobalMenuGTKSerializer* self, GtkImage* image) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (image != NULL);
	/*workaround a bug before Gtk 2.14*/
	if (GTK_IS_IMAGE_MENU_ITEM (gtk_widget_get_parent ((GtkWidget*) image))) {
		return;
	}
	/*Disable pure image menu item since
	  the purpose of introducing it was
	  to get Pidgin's menu icon tray working
	  but it turns out not working;
	  and causing issue 243
	sb.append(" type=\"icon\"");
	
	*
	 * adobe reader sucks. It doesn't use
	 * image menu item but use a hbox
	 * to contain the image
	 */
	self->priv->guessed_type = "i";
	global_menu_gtk_serializer_append_icon_attribute (self, image);
}


static char* global_menu_gtk_serializer_pixbuf_encode_b64 (GlobalMenuGTKSerializer* self, GdkPixbuf* pixbuf) {
	GdkPixdata pixdata = {(guint32) 0};
	guchar* _tmp1_;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (pixbuf != NULL, NULL);
	gdk_pixdata_from_pixbuf (&pixdata, pixbuf, TRUE);
	_tmp1_ = NULL;
	return (_tmp1_ = gdk_pixdata_serialize (&pixdata, &_tmp0_), g_base64_encode (_tmp1_, _tmp0_));
}


static void global_menu_gtk_serializer_append_icon_attribute (GlobalMenuGTKSerializer* self, GtkImage* image) {
	char* _tmp1_;
	char* _tmp0_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (image != NULL);
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	if ((_tmp2_ = (_tmp1_ = (g_object_get (image, "file", &_tmp0_, NULL), _tmp0_)) != NULL, _tmp1_ = (g_free (_tmp1_), NULL), _tmp2_)) {
		char* _tmp5_;
		char* _tmp4_;
		char* _tmp3_;
		_tmp5_ = NULL;
		_tmp4_ = NULL;
		_tmp3_ = NULL;
		g_string_append (self->priv->sb, _tmp5_ = g_markup_printf_escaped (" icon=\"file:%s\"", _tmp4_ = (g_object_get (image, "file", &_tmp3_, NULL), _tmp3_)));
		_tmp5_ = (g_free (_tmp5_), NULL);
		_tmp4_ = (g_free (_tmp4_), NULL);
	} else {
		if (gtk_image_get_storage_type (image) == GTK_IMAGE_STOCK) {
			char* _tmp6_;
			char* stock;
			/* STOCK is not shared between app and the applet */
			_tmp6_ = NULL;
			stock = (g_object_get (image, "stock", &_tmp6_, NULL), _tmp6_);
			if (g_str_has_prefix (stock, "gtk")) {
				char* _tmp7_;
				/*a GTK stock, shared between app and applet*/
				_tmp7_ = NULL;
				g_string_append (self->priv->sb, _tmp7_ = g_markup_printf_escaped (" icon=\"%s\"", stock));
				_tmp7_ = (g_free (_tmp7_), NULL);
			} else {
				if (!global_menu_gtk_disable_pixbuf) {
					char* _tmp9_;
					char* _tmp8_;
					GdkPixbuf* _tmp10_;
					GdkPixbuf* pixbuf;
					_tmp9_ = NULL;
					_tmp8_ = NULL;
					_tmp10_ = NULL;
					pixbuf = (_tmp10_ = gtk_widget_render_icon ((GtkWidget*) image, _tmp9_ = (g_object_get (image, "stock", &_tmp8_, NULL), _tmp8_), GTK_ICON_SIZE_MENU, NULL), _tmp9_ = (g_free (_tmp9_), NULL), _tmp10_);
					if (pixbuf != NULL) {
						char* _tmp12_;
						char* _tmp11_;
						_tmp12_ = NULL;
						_tmp11_ = NULL;
						g_string_append (self->priv->sb, _tmp12_ = g_markup_printf_escaped (" icon=\"pixbuf:%s\"", _tmp11_ = global_menu_gtk_serializer_pixbuf_encode_b64 (self, pixbuf)));
						_tmp12_ = (g_free (_tmp12_), NULL);
						_tmp11_ = (g_free (_tmp11_), NULL);
					}
					(pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL));
				}
			}
			stock = (g_free (stock), NULL);
		}
		if (gtk_image_get_storage_type (image) == GTK_IMAGE_ICON_NAME) {
			char* _tmp15_;
			char* _tmp14_;
			char* _tmp13_;
			/* THEME is shared between applet and the application*/
			_tmp15_ = NULL;
			_tmp14_ = NULL;
			_tmp13_ = NULL;
			g_string_append (self->priv->sb, _tmp15_ = g_markup_printf_escaped (" icon=\"theme:%s\"", _tmp14_ = (g_object_get (image, "icon-name", &_tmp13_, NULL), _tmp13_)));
			_tmp15_ = (g_free (_tmp15_), NULL);
			_tmp14_ = (g_free (_tmp14_), NULL);
		}
		if (gtk_image_get_storage_type (image) == GTK_IMAGE_PIXBUF) {
			if (!global_menu_gtk_disable_pixbuf) {
				GdkPixbuf* _tmp17_;
				GdkPixbuf* _tmp16_;
				gboolean _tmp18_;
				_tmp17_ = NULL;
				_tmp16_ = NULL;
				if ((_tmp18_ = (_tmp17_ = (g_object_get (image, "pixbuf", &_tmp16_, NULL), _tmp16_)) != NULL, (_tmp17_ == NULL) ? NULL : (_tmp17_ = (g_object_unref (_tmp17_), NULL)), _tmp18_)) {
					char* _tmp22_;
					char* _tmp21_;
					GdkPixbuf* _tmp20_;
					GdkPixbuf* _tmp19_;
					_tmp22_ = NULL;
					_tmp21_ = NULL;
					_tmp20_ = NULL;
					_tmp19_ = NULL;
					g_string_append (self->priv->sb, _tmp22_ = g_markup_printf_escaped (" icon=\"pixbuf:%s\"", _tmp21_ = global_menu_gtk_serializer_pixbuf_encode_b64 (self, _tmp20_ = (g_object_get (image, "pixbuf", &_tmp19_, NULL), _tmp19_))));
					_tmp22_ = (g_free (_tmp22_), NULL);
					_tmp21_ = (g_free (_tmp21_), NULL);
					(_tmp20_ == NULL) ? NULL : (_tmp20_ = (g_object_unref (_tmp20_), NULL));
				}
			}
		}
		if (gtk_image_get_storage_type (image) == GTK_IMAGE_PIXMAP) {
			gulong pixmap_xid;
			gulong mask_xid;
			GdkPixmap* _tmp24_;
			GdkPixmap* _tmp23_;
			gboolean _tmp25_;
			GdkPixmap* _tmp29_;
			GdkPixmap* _tmp28_;
			gboolean _tmp30_;
			char* _tmp33_;
			pixmap_xid = (gulong) 0;
			mask_xid = (gulong) 0;
			_tmp24_ = NULL;
			_tmp23_ = NULL;
			if ((_tmp25_ = (_tmp24_ = (g_object_get (image, "pixmap", &_tmp23_, NULL), _tmp23_)) != NULL, (_tmp24_ == NULL) ? NULL : (_tmp24_ = (g_object_unref (_tmp24_), NULL)), _tmp25_)) {
				GdkPixmap* _tmp27_;
				GdkPixmap* _tmp26_;
				_tmp27_ = NULL;
				_tmp26_ = NULL;
				pixmap_xid = GDK_DRAWABLE_XID ((GdkDrawable*) (_tmp27_ = (g_object_get (image, "pixmap", &_tmp26_, NULL), _tmp26_)));
				(_tmp27_ == NULL) ? NULL : (_tmp27_ = (g_object_unref (_tmp27_), NULL));
			}
			_tmp29_ = NULL;
			_tmp28_ = NULL;
			if ((_tmp30_ = (_tmp29_ = (g_object_get (image, "mask", &_tmp28_, NULL), _tmp28_)) != NULL, (_tmp29_ == NULL) ? NULL : (_tmp29_ = (g_object_unref (_tmp29_), NULL)), _tmp30_)) {
				GdkPixmap* _tmp32_;
				GdkPixmap* _tmp31_;
				_tmp32_ = NULL;
				_tmp31_ = NULL;
				mask_xid = GDK_DRAWABLE_XID ((GdkDrawable*) (_tmp32_ = (g_object_get (image, "mask", &_tmp31_, NULL), _tmp31_)));
				(_tmp32_ == NULL) ? NULL : (_tmp32_ = (g_object_unref (_tmp32_), NULL));
			}
			_tmp33_ = NULL;
			g_string_append (self->priv->sb, _tmp33_ = g_markup_printf_escaped (" icon=\"pixmap:%lu,%lu\"", pixmap_xid, mask_xid));
			_tmp33_ = (g_free (_tmp33_), NULL);
		}
	}
}


static void global_menu_gtk_serializer_indent (GlobalMenuGTKSerializer* self) {
	g_return_if_fail (self != NULL);
	if (!self->priv->pretty_print) {
		return;
	}
	if (!self->priv->newline) {
		return;
	}
	{
		gint i;
		i = 0;
		for (; i < self->priv->level; i++) {
			g_string_append_c (self->priv->sb, ' ');
		}
	}
	self->priv->newline = FALSE;
}


static void global_menu_gtk_serializer_linebreak (GlobalMenuGTKSerializer* self) {
	g_return_if_fail (self != NULL);
	if (!self->priv->pretty_print) {
		return;
	}
	g_string_append_c (self->priv->sb, '\n');
	self->priv->newline = TRUE;
}


static void global_menu_gtk_value_serializer_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void global_menu_gtk_value_serializer_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		global_menu_gtk_serializer_unref (value->data[0].v_pointer);
	}
}


static void global_menu_gtk_value_serializer_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = global_menu_gtk_serializer_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer global_menu_gtk_value_serializer_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* global_menu_gtk_value_serializer_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GlobalMenuGTKSerializer* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = global_menu_gtk_serializer_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* global_menu_gtk_value_serializer_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GlobalMenuGTKSerializer** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = global_menu_gtk_serializer_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* global_menu_gtk_param_spec_serializer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GlobalMenuGTKParamSpecSerializer* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GLOBAL_MENU_GTK_TYPE_SERIALIZER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer global_menu_gtk_value_get_serializer (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GLOBAL_MENU_GTK_TYPE_SERIALIZER), NULL);
	return value->data[0].v_pointer;
}


void global_menu_gtk_value_set_serializer (GValue* value, gpointer v_object) {
	GlobalMenuGTKSerializer* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GLOBAL_MENU_GTK_TYPE_SERIALIZER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GLOBAL_MENU_GTK_TYPE_SERIALIZER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		global_menu_gtk_serializer_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		global_menu_gtk_serializer_unref (old);
	}
}


static void global_menu_gtk_serializer_class_init (GlobalMenuGTKSerializerClass * klass) {
	global_menu_gtk_serializer_parent_class = g_type_class_peek_parent (klass);
	GLOBAL_MENU_GTK_SERIALIZER_CLASS (klass)->finalize = global_menu_gtk_serializer_finalize;
	g_type_class_add_private (klass, sizeof (GlobalMenuGTKSerializerPrivate));
}


static void global_menu_gtk_serializer_instance_init (GlobalMenuGTKSerializer * self) {
	self->priv = GLOBAL_MENU_GTK_SERIALIZER_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void global_menu_gtk_serializer_finalize (GlobalMenuGTKSerializer* obj) {
	GlobalMenuGTKSerializer * self;
	self = GLOBAL_MENU_GTK_SERIALIZER (obj);
	(self->priv->menubar == NULL) ? NULL : (self->priv->menubar = (g_object_unref (self->priv->menubar), NULL));
	(self->priv->sb == NULL) ? NULL : (self->priv->sb = (g_string_free (self->priv->sb, TRUE), NULL));
	(self->priv->label_sb == NULL) ? NULL : (self->priv->label_sb = (g_string_free (self->priv->label_sb, TRUE), NULL));
}


GType global_menu_gtk_serializer_get_type (void) {
	static GType global_menu_gtk_serializer_type_id = 0;
	if (global_menu_gtk_serializer_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { global_menu_gtk_value_serializer_init, global_menu_gtk_value_serializer_free_value, global_menu_gtk_value_serializer_copy_value, global_menu_gtk_value_serializer_peek_pointer, "p", global_menu_gtk_value_serializer_collect_value, "p", global_menu_gtk_value_serializer_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GlobalMenuGTKSerializerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) global_menu_gtk_serializer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GlobalMenuGTKSerializer), 0, (GInstanceInitFunc) global_menu_gtk_serializer_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		global_menu_gtk_serializer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GlobalMenuGTKSerializer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return global_menu_gtk_serializer_type_id;
}


gpointer global_menu_gtk_serializer_ref (gpointer instance) {
	GlobalMenuGTKSerializer* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void global_menu_gtk_serializer_unref (gpointer instance) {
	GlobalMenuGTKSerializer* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GLOBAL_MENU_GTK_SERIALIZER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




