
#include <glib.h>
#include <glib-object.h>
#include <testman.h>
#include <gtk/gtk.h>
#include <libwnck/libwnck.h>
#include <libgnomenu.h>
#include <stdlib.h>
#include <string.h>


#define GNOMENU_TYPE_TEST_APPLICATION (gnomenu_test_application_get_type ())
#define GNOMENU_TEST_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOMENU_TYPE_TEST_APPLICATION, GnomenuTestApplication))
#define GNOMENU_TEST_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOMENU_TYPE_TEST_APPLICATION, GnomenuTestApplicationClass))
#define GNOMENU_IS_TEST_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOMENU_TYPE_TEST_APPLICATION))
#define GNOMENU_IS_TEST_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOMENU_TYPE_TEST_APPLICATION))
#define GNOMENU_TEST_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOMENU_TYPE_TEST_APPLICATION, GnomenuTestApplicationClass))

typedef struct _GnomenuTestApplication GnomenuTestApplication;
typedef struct _GnomenuTestApplicationClass GnomenuTestApplicationClass;
typedef struct _GnomenuTestApplicationPrivate GnomenuTestApplicationPrivate;

struct _GnomenuTestApplication {
	TestMan parent_instance;
	GnomenuTestApplicationPrivate * priv;
};

struct _GnomenuTestApplicationClass {
	TestManClass parent_class;
};



GType gnomenu_test_application_get_type (void);
enum  {
	GNOMENU_TEST_APPLICATION_DUMMY_PROPERTY
};
static void _lambda0_ (GnomenuTestApplication* self);
static void __lambda0__gdata_test_func (gpointer self);
static GnomenuTestApplication* gnomenu_test_application_new (void);
static GnomenuTestApplication* gnomenu_test_application_construct (GType object_type);
static GnomenuTestApplication* gnomenu_test_application_new (void);
gint gnomenu_test_application_main (char** args, int args_length1);
static gpointer gnomenu_test_application_parent_class = NULL;



static void _lambda0_ (GnomenuTestApplication* self) {
	GtkBox* box;
	WnckScreen* _tmp0_;
	WnckScreen* screen;
	box = (GtkBox*) g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
	g_message ("test-application.vala:12: %p %p", ((TestMan*) self)->window, box);
	_tmp0_ = NULL;
	screen = (_tmp0_ = wnck_screen_get_default (), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	gnomenu_application_init ();
	wnck_screen_force_update (screen);
	{
		GList* app_collection;
		GList* app_it;
		app_collection = gnomenu_application_applications;
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
			GnomenuApplication* _tmp1_;
			GnomenuApplication* app;
			_tmp1_ = NULL;
			app = (_tmp1_ = (GnomenuApplication*) app_it->data, (_tmp1_ == NULL) ? NULL : gnomenu_application_ref (_tmp1_));
			{
				if (app->wnck_applications != NULL) {
					gtk_box_pack_start_defaults (box, gnomenu_application_get_proxy_item (app));
					if (gnomenu_application_get_not_in_menu (app)) {
						g_message ("test-application.vala:20: %s %s not in menu", gnomenu_application_get_readable_name (app), gnomenu_application_get_exec_path (app));
					}
				}
				(app == NULL) ? NULL : (app = (gnomenu_application_unref (app), NULL));
			}
		}
	}
	gtk_container_add ((GtkContainer*) ((TestMan*) self)->window, (GtkWidget*) box);
	gtk_widget_show_all ((GtkWidget*) ((TestMan*) self)->window);
	gtk_main ();
	(box == NULL) ? NULL : (box = (g_object_unref (box), NULL));
	(screen == NULL) ? NULL : (screen = (g_object_unref (screen), NULL));
}


static void __lambda0__gdata_test_func (gpointer self) {
	_lambda0_ (self);
}


static GnomenuTestApplication* gnomenu_test_application_construct (GType object_type) {
	GnomenuTestApplication * self;
	self = (GnomenuTestApplication*) test_man_construct (object_type, "/GlobalMenu");
	test_man_add ((TestMan*) self, "widget", __lambda0__gdata_test_func, self);
	return self;
}


static GnomenuTestApplication* gnomenu_test_application_new (void) {
	return gnomenu_test_application_construct (GNOMENU_TYPE_TEST_APPLICATION);
}


gint gnomenu_test_application_main (char** args, int args_length1) {
	GnomenuTestApplication* t;
	gint _tmp0_;
	g_test_init (&args_length1, &args, NULL);
	gtk_init (&args_length1, &args);
	t = gnomenu_test_application_new ();
	test_man_run ((TestMan*) t);
	return (_tmp0_ = 0, (t == NULL) ? NULL : (t = (g_object_unref (t), NULL)), _tmp0_);
}


int main (int argc, char ** argv) {
	g_type_init ();
	return gnomenu_test_application_main (argv, argc);
}


static void gnomenu_test_application_class_init (GnomenuTestApplicationClass * klass) {
	gnomenu_test_application_parent_class = g_type_class_peek_parent (klass);
}


static void gnomenu_test_application_instance_init (GnomenuTestApplication * self) {
}


GType gnomenu_test_application_get_type (void) {
	static GType gnomenu_test_application_type_id = 0;
	if (gnomenu_test_application_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuTestApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_test_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuTestApplication), 0, (GInstanceInitFunc) gnomenu_test_application_instance_init, NULL };
		gnomenu_test_application_type_id = g_type_register_static (TYPE_TEST_MAN, "GnomenuTestApplication", &g_define_type_info, 0);
	}
	return gnomenu_test_application_type_id;
}




