
#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>




extern char** filenames;
char** filenames = NULL;
extern char** names;
char** names = NULL;
extern char* namespace;
char* namespace = NULL;
extern char* class;
char* class = NULL;
char* pixbuf_encode_b64 (GdkPixbuf* pixbuf);
gint _main (char** args, int args_length1);

static const GOptionEntry options[] = {{"namespace", 'N', 0, G_OPTION_ARG_STRING, &namespace, "namespace name", NULL}, {"class", 'C', 0, G_OPTION_ARG_STRING, &class, "class name", NULL}, {"name", 'n', 0, G_OPTION_ARG_STRING_ARRAY, &names, "variable names", NULL}, {"", (gchar) 0, 0, G_OPTION_ARG_FILENAME_ARRAY, &filenames, "filenames", NULL}, {NULL}};


char* pixbuf_encode_b64 (GdkPixbuf* pixbuf) {
	GdkPixdata pixdata = {(guint32) 0};
	guchar* _tmp1_;
	gint _tmp0_;
	g_return_val_if_fail (pixbuf != NULL, NULL);
	gdk_pixdata_from_pixbuf (&pixdata, pixbuf, TRUE);
	_tmp1_ = NULL;
	return (_tmp1_ = gdk_pixdata_serialize (&pixdata, &_tmp0_), g_base64_encode (_tmp1_, _tmp0_));
}


gint _main (char** args, int args_length1) {
	GError * _inner_error_;
	GOptionContext* context;
	gint i;
	gint _tmp3_;
	_inner_error_ = NULL;
	context = g_option_context_new (" - Convert image to gnomenu string");
	g_option_context_add_main_entries (context, options, NULL);
	g_option_context_parse (context, &args_length1, &args, &_inner_error_);
	if (_inner_error_ != NULL) {
		(context == NULL) ? NULL : (context = (g_option_context_free (context), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return 0;
	}
	i = 0;
	if (namespace != NULL) {
		fprintf (stdout, "namespace %s {\n", namespace);
	}
	if (class != NULL) {
		fprintf (stdout, "\tclass %s {\n", class);
	}
	for (i = 0; TRUE; i++) {
		gboolean _tmp0_;
		const char* _tmp1_;
		char* filename;
		const char* _tmp2_;
		char* name;
		_tmp0_ = FALSE;
		if (filenames != NULL) {
			_tmp0_ = filenames[i] != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_tmp1_ = NULL;
		filename = (_tmp1_ = filenames[i], (_tmp1_ == NULL) ? NULL : g_strdup (_tmp1_));
		_tmp2_ = NULL;
		name = (_tmp2_ = names[i], (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_));
		{
			GdkPixbuf* pixbuf;
			char* str;
			pixbuf = gdk_pixbuf_new_from_file (filename, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch0_g_error;
				goto __finally0;
			}
			str = pixbuf_encode_b64 (pixbuf);
			if (class != NULL) {
				fprintf (stdout, "\t\tpublic static ");
			} else {
				fprintf (stdout, "\tpublic ");
			}
			fprintf (stdout, "const string %s = \"\"\"pixbuf:%s\"\"\";\n", names[i], str);
			(pixbuf == NULL) ? NULL : (pixbuf = (g_object_unref (pixbuf), NULL));
			str = (g_free (str), NULL);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_warning ("image-to-vala.vala:48: %s", e->message);
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally0:
		if (_inner_error_ != NULL) {
			filename = (g_free (filename), NULL);
			name = (g_free (name), NULL);
			(context == NULL) ? NULL : (context = (g_option_context_free (context), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return 0;
		}
		filename = (g_free (filename), NULL);
		name = (g_free (name), NULL);
	}
	if (class != NULL) {
		fprintf (stdout, "\t}\n");
	}
	if (namespace != NULL) {
		fprintf (stdout, "}\n");
	}
	return (_tmp3_ = 0, (context == NULL) ? NULL : (context = (g_option_context_free (context), NULL)), _tmp3_);
}


int main (int argc, char ** argv) {
	g_type_init ();
	return _main (argv, argc);
}




